Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree
Class ElementImpl

    java.lang.Object
      net.sf.saxon.tree.NodeImpl
          net.sf.saxon.tree.ParentNodeImpl
              net.sf.saxon.tree.ElementImpl

All Implemented Interfaces:
  FingerprintedNode, Item, NodeInfo, javax.xml.transform.Source, javax.xml.transform.SourceLocator, ValueRepresentation

Direct Known Subclasses:
  ElementWithAttributes

public class ElementImpl
extends net.sf.saxon.tree.ParentNodeImpl

ElementImpl implements an element with no attributes or namespace declarations.

This class is an implementation of NodeInfo. For elements with attributes or namespace declarations, class ElementWithAttributes is used.

Field Summary
`protected int` | `nameCode`
`protected DocumentImpl` | `root`
`protected int` | `sequence`

Fields inherited from class net.sf.saxon.tree.NodeImpl
`index, NODE_LETTER, parent`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`ElementImpl()` Construct an empty ElementImpl

Method Summary
`void` | `addChild(NodeImpl node, int index)` Add a child node to this node.
`void` | `compact(int size)` Compact the space used by this node
`void` | `copy(Receiver out, int whichNamespaces, boolean copyAnnotations, int locationId)` Copy this node to a given outputter (supporting xsl:copy-of)
`AxisIterator` | `enumerateChildren(NodeTest test)` Get an enumeration of the children of this node
`void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node
`AttributeCollection` | `getAttributeList()` Get the attribute list for this element.
`java.lang.String` | `getBaseURI()` Get the base URI of this element node.
`int[]` | `getDeclaredNamespaces(int[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`DocumentInfo` | `getDocumentRoot()` Get the root document node
`NodeInfo` | `getFirstChild()` Get the first child node of the element
`NodeInfo` | `getLastChild()` Get the last child node of the element
`int` | `getLineNumber()` Get the line number of the node within its source document entity
`int` | `getNameCode()` Get the nameCode of the node.
`int` | `getNodeKind()` Return the type of node.
`protected NodeImpl` | `getNthChild(int n)` Get the nth child node of the element (numbering from 0)
`NodeInfo` | `getRoot()` Get the root node
`protected long` | `getSequenceNumber()` Get the node sequence number (in document order).
`java.lang.String` | `getStringValue()` Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.
`java.lang.CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`java.lang.String` | `getSystemId()` Get the system ID of the entity containing this element node.
`boolean` | `hasChildNodes()` Determine if the node has any children.
`void` | `initialise(int nameCode, AttributeCollectionImpl atts, NodeInfo parent, java.lang.String baseURI, int lineNumber, int sequenceNumber)` Initialise a new ElementImpl with an element name
`void` | `sendNamespaceDeclarations(Receiver out, boolean includeAncestors)` Output all namespace nodes associated with this element.
`void` | `setLineNumber(int line)` Set the line number of the element within its source document entity
`void` | `setNameCode(int nameCode)` Set the name code.
`void` | `setSystemId(java.lang.String uri)` Set the system ID of this node.
`void` | `useChildrenArray(NodeImpl[] array)` Supply an array to be used for the array of children.

Methods inherited from class net.sf.saxon.tree.NodeImpl
`atomize, compareOrder, equals, getAttributeValue, getColumnNumber, getConfiguration, getDisplayName, getDocumentNumber, getFingerprint, getLocalPart, getNamePool, getNextInDocument, getNextSibling, getParent, getPrefix, getPreviousInDocument, getPreviousSibling, getPublicId, getTypeAnnotation, getTypedValue, getURI, hashCode, isSameNodeInfo, iterateAxis, iterateAxis`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### nameCode

    protected int nameCode

### root

    protected DocumentImpl root

### sequence

    protected int sequence

Constructor Detail

### ElementImpl

    public ElementImpl()

  Construct an empty ElementImpl

Method Detail

### setNameCode

    public void setNameCode(int nameCode)

  Set the name code. Used when creating a dummy element in the Stripper

### initialise

    public void initialise(int nameCode,
                           AttributeCollectionImpl atts,
                           NodeInfo parent,
                           java.lang.String baseURI,
                           int lineNumber,
                           int sequenceNumber)

  Initialise a new ElementImpl with an element name

  Parameters:
    `nameCode` - Integer representing the element name, with namespaces resolved
    `atts` - The attribute list: always null
    `parent` - The parent node
    `baseURI` - The base URI of the new element
    `lineNumber` - The line number of the element in the source document
    `sequenceNumber` - Integer identifying this element within the document

### setSystemId

    public void setSystemId(java.lang.String uri)

  Set the system ID of this node. This method is provided so that a NodeInfo implements the javax.xml.transform.Source interface, allowing a node to be used directly as the Source of a transformation

  Specified by:
    `setSystemId` in interface `javax.xml.transform.Source`
  Overrides:
    `setSystemId` in class `NodeImpl`

### getRoot

    public NodeInfo getRoot()

  Get the root node

  Specified by:
    `getRoot` in interface `NodeInfo`
  Overrides:
    `getRoot` in class `NodeImpl`
  Returns:
    the NodeInfo representing the containing document

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root document node

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Overrides:
    `getDocumentRoot` in class `NodeImpl`
  Returns:
    the DocumentInfo representing the containing document

### getSystemId

    public final java.lang.String getSystemId()

  Get the system ID of the entity containing this element node.

  Specified by:
    `getSystemId` in interface `NodeInfo`
  Overrides:
    `getSystemId` in class `NodeImpl`

### getBaseURI

    public java.lang.String getBaseURI()

  Get the base URI of this element node. This will be the same as the System ID unless xml:base has been used.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Overrides:
    `getBaseURI` in class `NodeImpl`

### setLineNumber

    public void setLineNumber(int line)

  Set the line number of the element within its source document entity

### getLineNumber

    public int getLineNumber()

  Get the line number of the node within its source document entity

  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Overrides:
    `getLineNumber` in class `NodeImpl`

### getNameCode

    public int getNameCode()

  Get the nameCode of the node. This is used to locate the name in the NamePool

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Overrides:
    `getNameCode` in class `NodeImpl`

### generateId

    public void generateId(FastStringBuffer buffer)

  Get a character string that uniquely identifies this node

  Specified by:
    `generateId` in interface `NodeInfo`
  Overrides:
    `generateId` in class `NodeImpl`
  Parameters:
    `buffer` - to contain the generated ID

### sendNamespaceDeclarations

    public void sendNamespaceDeclarations(Receiver out,
                                          boolean includeAncestors)
                                   throws XPathException

  Output all namespace nodes associated with this element.

  Specified by:
    `sendNamespaceDeclarations` in interface `NodeInfo`
  Overrides:
    `sendNamespaceDeclarations` in class `NodeImpl`
  Parameters:
    `out` - The relevant outputter
    `includeAncestors` - True if namespaces declared on ancestor elements must
  Throws:
    `XPathException`

### getDeclaredNamespaces

    public int[] getDeclaredNamespaces(int[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Overrides:
    `getDeclaredNamespaces` in class `NodeImpl`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### getNodeKind

    public final int getNodeKind()

  Return the type of node.

  Returns:
    Type.ELEMENT
  See Also:
    `Type`

### getAttributeList

    public AttributeCollection getAttributeList()

  Get the attribute list for this element.

  Returns:
    The attribute list. This will not include any namespace attributes. The attribute names will be in expanded form, with prefixes replaced by URIs

### copy

    public void copy(Receiver out,
                     int whichNamespaces,
                     boolean copyAnnotations,
                     int locationId)
              throws XPathException

  Copy this node to a given outputter (supporting xsl:copy-of)

  Parameters:
    `out` - The outputter
    `whichNamespaces` - indicates which namespaces should be output: all, none, or local namespaces only (those not declared on the parent element)
    `copyAnnotations` - indicates whether the type annotations of element and attribute nodes should be copied
    `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information for the original node is to be copied; in this case the Receiver must be a LocationCopier
  Throws:
    `XPathException`

### getSequenceNumber

    protected final long getSequenceNumber()

  Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. In the current implementation, parent nodes (elements and roots) have a zero least-significant word, while namespaces, attributes, text nodes, comments, and PIs have the top word the same as their owner and the bottom half reflecting their relative position.

  Overrides:
    `getSequenceNumber` in class `NodeImpl`

### hasChildNodes

    public final boolean hasChildNodes()

  Determine if the node has any children.

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Overrides:
    `hasChildNodes` in class `NodeImpl`
  Returns:
    `true` if the node has any children, `false` if the node has no children.

### enumerateChildren

    public final AxisIterator enumerateChildren(NodeTest test)

  Get an enumeration of the children of this node

  Parameters:
    `test` - A NodeTest to be satisfied by the child nodes, or null if all child node are to be returned

### getFirstChild

    public final NodeInfo getFirstChild()

  Get the first child node of the element

  Overrides:
    `getFirstChild` in class `NodeImpl`
  Returns:
    the first child node of the required type, or null if there are no children

### getLastChild

    public final NodeInfo getLastChild()

  Get the last child node of the element

  Overrides:
    `getLastChild` in class `NodeImpl`
  Returns:
    the last child of the element, or null if there are no children

### getNthChild

    protected final NodeImpl getNthChild(int n)

  Get the nth child node of the element (numbering from 0)

  Returns:
    the last child of the element, or null if there is no n'th child

### getStringValue

    public java.lang.String getStringValue()

  Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.

  Returns:
    the accumulated character content of the element, including descendant elements.

### getStringValueCS

    public java.lang.CharSequence getStringValueCS()

  Description copied from class: `NodeImpl`
  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item`
  Overrides:
    `getStringValueCS` in class `NodeImpl`

### useChildrenArray

    public void useChildrenArray(NodeImpl[] array)

  Supply an array to be used for the array of children. For system use only.

### addChild

    public void addChild(NodeImpl node,
                         int index)

  Add a child node to this node. For system use only. Note: normalizing adjacent text nodes is the responsibility of the caller.

### compact

    public void compact(int size)

  Compact the space used by this node

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD